#!/usr/bin/env node
'use strict';

var _open = require('open');

var _open2 = _interopRequireDefault(_open);

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _ = require('../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var argv = _yargs2.default.option('proxy', {
  description: 'URL to proxy to',
  type: 'string'
}).help('help').argv;

global.__IN_DEV_SERVER = true;

var proxies = (Array.isArray(argv.proxy) ? argv.proxy : argv.proxy && [argv.proxy] || []).map(function (url) {
  return { url: url };
});

var server = (0, _.createServer)(argv._, {
  proxies: proxies
});

/* eslint no-console: 0 */
server.on('ready', function () {
  console.log('💎  Ready.');
});

server.listen(process.env.PORT, function () {
  var url = 'http://localhost:' + server.address().port + '/';
  console.log('💎  Listening: ' + url + '.');
  if (!process.env.PORT) {
    (0, _open2.default)(url);
  }
});
//# sourceMappingURL=webpack-udev-server.js.map