'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _interpret = require('interpret');

var _interpret2 = _interopRequireDefault(_interpret);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var registerCompiler = function registerCompiler(moduleDescriptor) {
  if (moduleDescriptor) {
    if (typeof moduleDescriptor === 'string') {
      require(moduleDescriptor);
    } else if (!Array.isArray(moduleDescriptor)) {
      moduleDescriptor.register(require(moduleDescriptor.module));
    } else {
      for (var i = 0; i < moduleDescriptor.length; i++) {
        try {
          registerCompiler(moduleDescriptor[i]);
          break;
        } catch (e) {
          // do nothing
        }
      }
    }
  }
};

exports.default = function (entry) {
  var extensions = Object.keys(_interpret2.default.extensions).sort(function (a, b) {
    return a.length - b.length;
  });
  var configPath = (0, _path.resolve)(entry);
  var ext = undefined;
  for (var i = extensions.length - 1; i >= 0; i--) {
    var tmpExt = extensions[i];
    if (configPath.indexOf(tmpExt, configPath.length - tmpExt.length) > -1) {
      ext = tmpExt;
      break;
    }
  }
  if (!ext) {
    ext = (0, _path.extname)(configPath);
  }
  registerCompiler(_interpret2.default.extensions[ext]);
  var value = require(configPath);
  if (value && value.__esModule) {
    return value.default;
  }
  return value;
};
//# sourceMappingURL=load.js.map