'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

var _ipc = require('../ipc');

var _ipc2 = _interopRequireDefault(_ipc);

var _flowRight = require('lodash/flowRight');

var _flowRight2 = _interopRequireDefault(_flowRight);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _thunk = require('http-middleware-metalab/middleware/thunk');

var _thunk2 = _interopRequireDefault(_thunk);

var _assets = require('http-middleware-metalab/middleware/assets');

var _send = require('http-middleware-metalab/middleware/send');

var _send2 = _interopRequireDefault(_send);

var _status = require('http-middleware-metalab/middleware/status');

var _status2 = _interopRequireDefault(_status);

var _match = require('http-middleware-metalab/middleware/match');

var _match2 = _interopRequireDefault(_match);

var _http3 = require('http-middleware-metalab/adapter/http');

var _http4 = _interopRequireDefault(_http3);

var _memoryFs = require('memory-fs');

var _memoryFs2 = _interopRequireDefault(_memoryFs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (compiler) {
  if (compiler.options.target !== 'web') {
    return;
  }

  var fs = compiler.outputFileSystem = new _memoryFs2.default();

  if (!compiler.options.output.publicPath) {
    compiler.options.output.publicPath = Math.random().toString(36).substr(2);
  }

  var server = _http2.default.createServer();
  var app = (0, _flowRight2.default)((0, _thunk2.default)(function (app) {
    var result = app;
    compiler.plugin('done', function (stats) {
      result = (0, _match2.default)((0, _assets.asset)(stats.toJson()), function (app) {
        return _extends({}, app, {
          request: function request(req, res) {
            var file = _path2.default.join(compiler.outputPath, req.asset.name);
            var data = fs.readFileSync(file);
            res.statusCode = 200;
            res.setHeader('Content-Type', req.asset.contentType);
            res.setHeader('Content-Length', data.length);
            res.end(data);
          }
        });
      })(app);
    });
    return function () {
      return result;
    };
  }), (0, _flowRight2.default)((0, _send2.default)(), (0, _status2.default)(404)))({
    request: function request() {},
    error: function error() {}
  });

  server.on('listening', function () {
    var address = server.address();
    var path = compiler.options.output.publicPath;
    _ipc2.default.emit('proxy', {
      url: 'http://localhost:' + address.port + path
    });
  });

  (0, _http4.default)(app, server).listen();
};
//# sourceMappingURL=web.js.map