'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _thunk = require('http-middleware-metalab/middleware/thunk');

var _thunk2 = _interopRequireDefault(_thunk);

var _assets = require('http-middleware-metalab/middleware/assets');

var _ipc = require('../ipc');

var _ipc2 = _interopRequireDefault(_ipc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Middleware for your application that monitors a particular webpack stats
 * object and then attaches information about those stats to the request. The
 * webpack stats object being monitored does not have to exist in the calling
 * process.
 *
 * @param {String} file Path to any file in the build.
 * @returns {Function} Middleware function.
 */

exports.default = function (file) {
  return (0, _thunk2.default)(function (app) {
    var result = app;
    var source = _path2.default.resolve(file);

    // Monitor the desired file.
    _ipc2.default.emit('watch-file', source);

    // When we get a stats object from the file we care about then update the
    // middleware to attach the relevant asset information.
    _ipc2.default.on('stats', function (stats, origin) {
      if (origin === source) {
        result = (0, _assets.request)(stats)(app);
      }
    });

    return function () {
      return result;
    };
  });
};
//# sourceMappingURL=dev-assets.js.map