'use strict';

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

var _ipc = require('../ipc');

var _ipc2 = _interopRequireDefault(_ipc);

var _common = require('./common');

var _common2 = _interopRequireDefault(_common);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var listen = _http2.default.Server.prototype.listen;

// Hack the HTTP server prototype to send address information upstream.
/* global __webpack_public_path__ */
_http2.default.Server.prototype.listen = function () {
  var _this = this;
  this.once('listening', function () {
    var address = _this.address();
    var path = __webpack_public_path__ || '/'; // eslint-disable-line
    _ipc2.default.emit('proxy', {
      url: 'http://localhost:' + address.port + path
    });
  });
  listen.apply(this, arguments);
};

(0, _common2.default)({
  reload: function reload() {
    console.log('🔥  Requested full reload. Killing app.');
    process.exit(218);
  }
});
//# sourceMappingURL=dev-server.js.map