'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

var _child_process = require('child_process');

var _path = require('path');

var _chokidar = require('chokidar');

var _socket = require('socket.io');

var _socket2 = _interopRequireDefault(_socket);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _flowRight = require('lodash/flowRight');

var _flowRight2 = _interopRequireDefault(_flowRight);

var _matches = require('lodash/matches');

var _matches2 = _interopRequireDefault(_matches);

var _reject = require('lodash/reject');

var _reject2 = _interopRequireDefault(_reject);

var _send = require('http-middleware-metalab/middleware/send');

var _send2 = _interopRequireDefault(_send);

var _status = require('http-middleware-metalab/middleware/status');

var _status2 = _interopRequireDefault(_status);

var _proxy = require('http-middleware-metalab/middleware/proxy');

var _proxy2 = _interopRequireDefault(_proxy);

var _http3 = require('http-middleware-metalab/adapter/http');

var _http4 = _interopRequireDefault(_http3);

var _match = require('http-middleware-metalab/middleware/match');

var _match2 = _interopRequireDefault(_match);

var _path2 = require('http-middleware-metalab/middleware/match/path');

var _path3 = _interopRequireDefault(_path2);

var _thunk = require('http-middleware-metalab/middleware/thunk');

var _thunk2 = _interopRequireDefault(_thunk);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Server = function (_http$Server) {
  _inherits(Server, _http$Server);

  function Server(configs) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    _classCallCheck(this, Server);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Server).call(this));

    var app = (0, _flowRight2.default)((0, _thunk2.default)(function (app) {
      var result = app;
      _this.on('proxies', function (proxies) {
        result = proxies.slice().sort(function (a, b) {
          return a.path.split('/').length - b.path.split('/').length;
        }).reduce(function (result, info) {
          return (0, _match2.default)((0, _path3.default)(info.path), (0, _proxy2.default)(info))(result);
        }, app);
      });
      return function () {
        return result;
      };
    }), (0, _flowRight2.default)((0, _status2.default)(404), (0, _send2.default)('Hello.')))({
      error: function error(err) {
        // TODO: Once the error handling has been standardized, as per:
        // https://github.com/metalabdesign/http-middleware-metalab/issues/30
        // Do something useful here.
        console.log('ERROR', err);
      },
      request: function request(req, res) {
        console.log('UNREACHABLE', req.url);
        res.end();
      }
    });

    _this.compilers = {};
    _this.configs = configs;
    _this.proxies = [];

    _this.ready = false;
    _this.state = {};
    _this.stats = {};

    _this.on('listening', function () {
      if (_this.watcher) {
        _this.watcher.close();
      }
      _this.watcher = (0, _chokidar.watch)(_this.configs);
      _this.watcher.on('add', function (file) {
        return _this.load(file);
      }).on('change', function (file) {
        return _this.load(file);
      }).on('unlink', function (file) {
        return _this.unload(file);
      }).on('error', function (err) {
        return _this.emit('error', err);
      });
    });

    _this.on('close', function () {
      if (_this.watcher) {
        _this.watcher.close();
        _this.watcher = null;
      }
    });

    (0, _http4.default)(app, _this);

    // io.listen has to come after the normal app because of how it
    // overwrites the request handlers.
    _this.ipc = _socket2.default.listen(_this, {
      // TODO: Don't dominate the / namespace!
      // path: '____',
    });

    _this.ipc.on('connection', function (socket) {
      // Since we are essentially just a "smart proxy" we take requests to
      // serve things at a particular URL and do so.
      socket.on('proxy', function (info) {
        // Add proxy to our internal list of proxies.
        _this.proxy({
          url: info.url,
          socket: socket.id
        });
      });

      // Take the resultant stats from child compilers and broadcast them
      // to everyone else on the IPC network. This is useful for things
      // which depend on having access to someone else stats object like a
      // server knowing the client's stats.
      socket.on('stats', function (stats) {
        _this.stats[socket.id] = stats;
        _this.ipc.in('/compiler/' + stats.token).emit('stats', stats);
        stats.assets.forEach(function (asset) {
          var path = (0, _path.join)(stats.outputPath, asset.name);
          _this.ipc.in('/file' + path).emit('stats', stats, path);
        });
      });

      // Someone just died.
      socket.on('disconnect', function () {
        _this.unproxy({
          socket: socket.id
        });
        // Delete all their stats.
        delete _this.stats[socket.id];
      });

      socket.on('watch-stats', function (token) {
        socket.join('/compiler/' + token);
        Object.keys(_this.stats).forEach(function (key) {
          if (_this.stats[key].token === token) {
            socket.emit('stats', _this.stats[key]);
          }
        });
      });

      socket.on('unwatch-stats', function (token) {
        socket.leave('/compiler/' + token);
      });

      socket.on('watch-file', function (file) {
        socket.join('/file' + file);
        Object.keys(_this.stats).forEach(function (key) {
          if (_this.stats[key].assets.some(function (_ref) {
            var name = _ref.name;

            return (0, _path.join)(_this.stats[key].outputPath, name) === file;
          })) {
            socket.emit('stats', _this.stats[key], file);
          }
        });
      });

      socket.on('unwatch-file', function (file) {
        socket.leave('/file' + file);
      });
    });

    // Add custom proxies if desired.
    if (options.proxies) {
      options.proxies.forEach(function (proxy) {
        return _this.proxy(proxy);
      });
    }
    return _this;
  }

  _createClass(Server, [{
    key: 'proxy',
    value: function proxy(options) {
      var parts = _url2.default.parse(options.url);
      this.proxies.push(_extends({
        target: {
          host: parts.hostname,
          port: parts.port
        },
        path: parts.pathname
      }, options));
      console.log('↔️  ' + parts.pathname + ' => ' + options.url);
      // Update actual proxy configuration.
      this.emit('proxies', this.proxies);
    }
  }, {
    key: 'unproxy',
    value: function unproxy(match) {
      // Delete all their registered proxies.
      this.proxies = (0, _reject2.default)(this.proxies, (0, _matches2.default)(match));
      // Update actual proxy configuration.
      this.emit('proxies', this.proxies);
    }
  }, {
    key: 'load',
    value: function load(config) {
      if (this.compilers[config]) {
        this.unload(config);
      }
      var address = this.address();
      var exe = (0, _path.join)(__dirname, 'compiler.js');
      console.log('🚀  Launching compiler for', (0, _path.basename)(config));
      var compiler = this.compilers[config] = (0, _child_process.fork)(exe, [config], {
        stdio: 'inherit',
        env: _extends({}, process.env, {
          IPC_URL: 'http://localhost:' + address.port + '/'
        })
      });
      return compiler;
    }
  }, {
    key: 'unload',
    value: function unload(config) {
      console.log('☠️  Killing compiler for', (0, _path.basename)(config));
      (0, _util.kill)(this.compilers[config]);
      delete this.compilers[config];
    }
  }]);

  return Server;
}(_http2.default.Server);

exports.default = Server;
//# sourceMappingURL=server.js.map